/****************************************************************************************
    Copyright 2004 uja 
    Copyright 2004 Trolltech (Qt3)
    This file is part of Ballonschiessen which runs under GPL
*****************************************************************************************/
#include "wiese.h"
#include <math.h> // Trefferberechnung Ellipse

// Treffer in ovales Bild mit den Koordinaten sx/sy und den Radien rx und ry=1.5*rx (Bildparameter)
bool getroffen(int xx,int yy,int sx,int sy,int wx)
{ 
  int rx=wx/2,ry=rx*3/2,mx=sx+rx,my=sy+ry,dy=yy-my,dx=xx-mx;
  float alpha,dx0,dy0;
  bool drin=((abs(xx-mx)<=rx) && (abs(yy-my)<=ry)); // Planquadrat getroffen
  if (drin) 
  { drin=((xx==mx) || (yy==my)); // einen der Durchmesser getroffen
    if (!drin) // Abstaende xx/yy vom Ellipsenmittelpunkt und Schnittpunkt der Linie xx/yy - mx/my mit Ellipsenbogen
    { 
      alpha=atan(dy/dx); 
      dx0=rx*cos(alpha);
      dy0=ry*sin(alpha);
      drin=(dx*dx+dy*dy<=dx0*dx0+dy0*dy0); 
    }
  }
  return drin;
}

// ======================================================================================================================  

ballon::ballon(int i) { id=i; typ=0; wert=5; zustand=2*NUMTYPEN+1; }

void ballon::starten(int nr)
{ 
  typ=rand()%NUMTYPEN; zustand=typ; 
  p_sprite->setY(rand()%192+16);
  riwechsel();
  if (p_sprite->xVelocity()>0) p_sprite->setX(0); else p_sprite->setX(XMAX+OFX); 
  p_sprite->setFrame(typ); if ((typ==0) && (nr>=0)) p_sprite->setFrame(2*NUMTYPEN+nr);
  p_sprite->setActive(true);
  p_sprite->show();
}

void ballon::riwechsel() { float speed[8]={-2,-1.5,-1,-0.5,0.5,1,1.5,2},ri=speed[rand()%8]; wert=abs(ri*10); p_sprite->setVelocity(ri,0); }
void ballon::treffer()   { zustand=typ+NUMTYPEN; p_sprite->setFrame(zustand); p_sprite->setVelocity(0,4); }
bool ballon::im_pott()   { int i=(p_sprite->x()-OFX-96+p_sprite->width()/2)/DX; return (i==typ); }
void ballon::weg()       { zustand=2*NUMTYPEN+1; p_sprite->hide(); }

// ====================================================================================================================

wiese::wiese(QWidget* parent)
{ 
  int i;
  for (i=0; i<NUMSPRITES; i++) my_ballon[i]=new ballon(i);
  my_timer  =new QTimer(this); // Sekundenzaehler
  my_stopper=new QTimer(this); // fuer singleShot
  tic=50;                      // Ballonbewegung, 50Hz
  aktiv=false;
// Sekundenticker und Ani-Ticker: ---  
  connect(my_timer,SIGNAL(timeout()),this,SLOT(ticken())); my_timer->start(1000);
  connect(my_stopper,SIGNAL(timeout()),this,SLOT(move_all())); my_stopper->start(tic);
// Anzeigen window: ---  
  connect(this,SIGNAL(punkte_changed(int)),parent,SLOT(set_punkte(int)));    // Anzeige Punkte
  connect(this,SIGNAL(zeit_changed(int)),  parent,SLOT(set_zeit(int)));      // Anzeige Restzeit
}

// Slots intern und Anzeigen: --------------------------------------------------------------------------------------
void wiese::game_over() { aktiv=false; p_gover->show(); emit gameover(punkte); } // noch auswerten
void wiese::ticken() { if (aktiv) { zeit--; if (zeit<0) game_over(); else emit zeit_changed(zeit); } }

// slots User Interface: ---------------------------------------------------------------------------------------------
void wiese::pause()    { aktiv=false; pausiert=true;  p_pause->show(); }
void wiese::weiter()   { aktiv=true;  pausiert=false; p_pause->hide(); ballon_raus(); }

void wiese::ballon_raus()
{
  if (aktiv) if (draussen<NUMSPRITES)
  { my_ballon[draussen]->starten(upic);
    draussen++;
    QTimer::singleShot(5000,this,SLOT(ballon_raus()));
  }
}

void wiese::neues_spiel() 
{ 
  aktiv=false;
  srand(time(0));
  for (int i=0; i<NUMSPRITES; i++) my_ballon[i]->weg(); 
  punkte=0;
  zeit=ZEIT0;
  draussen=0;
  emit punkte_changed(punkte);
  emit zeit_changed(zeit);
  p_gover->hide();
  weiter();
}

void wiese::move_all()
{
  if (aktiv) for (int i=0; i<NUMSPRITES; i++) if (my_ballon[i]->zustand<2*NUMTYPEN)
  { // Flugbahn:
    if (my_ballon[i]->zustand<NUMTYPEN) if (rand()%50<1) my_ballon[i]->riwechsel();
    if (my_ballon[i]->p_sprite->x()>XMAX+OFX) my_ballon[i]->p_sprite->setX(0); 
    else if (my_ballon[i]->p_sprite->x()<0) my_ballon[i]->p_sprite->setX(XMAX+OFX);
    if (my_ballon[i]->zustand>=NUMTYPEN) // zerschossen
    {
      if (my_ballon[i]->p_sprite->y()>OFY-DY) 
      { 
        if (my_ballon[i]->im_pott()) punkte=punkte+my_ballon[i]->wert; else punkte--;	 
         emit punkte_changed(punkte);
	 my_ballon[i]->weg();
	 my_ballon[i]->starten(upic);
      }
    }
  }
}


void wiese::klick(int xx,int yy)
{ 
  int i,k=-1;
  if (aktiv) 
  { 
    for (i=0; i<NUMSPRITES; i++) if (my_ballon[i]->zustand<NUMTYPEN)
     if (getroffen(xx,yy,my_ballon[i]->p_sprite->x(),my_ballon[i]->p_sprite->y(),my_ballon[i]->p_sprite->width())) if (i>k) k=i;
    if (k>=0) { my_ballon[k]->treffer(); if (my_ballon[k]->typ==0) { punkte=punkte+10; emit punkte_changed(punkte); } }
  }    
  else if (pausiert) weiter(); 
}

void wiese::userpic(int nr) 
{ 
  upic=nr;
  for (int i=0; i<NUMSPRITES; i++) if (my_ballon[i]->zustand==0) my_ballon[i]->p_sprite->setFrame(2*NUMTYPEN+upic);   
}

void wiese::save_settings()
{
  QFile file(SETFILE); 
  QString buff,b;
  b.setNum(upic);
  buff=b+"\n";
  if (file.open(IO_WriteOnly)) { file.writeBlock(buff,buff.length()); file.close(); }
}


void wiese::move_cursor(int xx,int yy) { p_cursor->move(xx-16,yy-16); }
 
// ===============================================================================================================
