/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)
    This file is part of Ballonschiessen which runs under GPL
*****************************************************************************************/
// Definition Ballons-Toepfe-Wiese:

#ifndef WIESE_H
#define WIESE_H
 
#include "config.h"
#include <qcanvas.h>
#include <qtimer.h>
#include <qfile.h>
#include <stdio.h> // debugging
// ----------------------------------------------------------------------------------------------------------------------

class ballon
{
   public:
   ballon(int);
   int id,typ,zustand,wert;
   QCanvasSprite* p_sprite;
     
   void starten(int); // Userpic-Uebergabe
   void riwechsel();
   void treffer();
   bool im_pott();
   void weg();
};


class wiese:public QCanvas
{
  Q_OBJECT
  
  public:
  wiese(QWidget* parent=0);
  
  // alle Bilder:
  QCanvasPixmapArray* my_zielarray;   // Toepfe
  QCanvasPixmapArray* my_vgarray;     // Vordergrundbild, 88x600
  QCanvasPixmapArray* my_ballonarray; // Ballonzustaende
  QCanvasPixmapArray* my_tropfenarray; // Ballonzustaende
  QCanvasPixmapArray* my_goverarray;  // gameover
  QCanvasPixmapArray* my_pausearray;  // pause
  QCanvasPixmapArray* my_cursorarray; // Fadenkreuz
  
  QCanvasSprite* p_zielsprite[NUMTYPEN];     // Transporterdeckel-Sprite
  QCanvasSprite* p_pause;
  QCanvasSprite* p_gover;
  QCanvasSprite* p_vg;
  QCanvasSprite* p_cursor;
    
  // userpics:
  QCanvasPixmap* p_userpics[NUMSPRITES];  
  
  ballon* my_ballon[NUMSPRITES];
  bool aktiv,pausiert;          // Flags
  int punkte,zeit,tic,draussen,upic; // Spielparameter
  QTimer* my_timer;
  QTimer* my_stopper;
  
  void game_over();
  
  private slots:
  void ticken();
  void move_all();
 
  public slots:
  void neues_spiel();               // Start von Level0 aus
  void ballon_raus();
  void pause(); 
  void weiter();                    
  void klick(int,int);              // Klick ins Feld, Pfeil setzen oder drehen
  void userpic(int);     // User-Bild
  void move_cursor(int,int); 
  void save_settings();
  
  signals:
  void punkte_changed(int);         // an window, Punkte anzeigen
  void zeit_changed(int);           // an window, Restzeit anzeigen
  void gameover(int);  // Gameover-Bild, Punkte weiterreichen und bei Bedarf HSC-Eintrag
};

#endif
